//проверка часов ds3231  wire
//ATmega324PB
#define F_CPU  14745600UL

#define LED0 (1<<5)

#define BUAD  9600
#define BRC   ((F_CPU/16/BUAD) - 1) 

#include <Wire.h>

volatile byte second, minute, hour, date, month, year;
volatile byte sek=0; //внутренний отсчет секунд
volatile byte Flag=0;

void setup() {
  Wire.begin();  // Join i2c bus
  DDRD  |= LED0;
  PORTD |= LED0;

  UBRR2H = (unsigned char) (BRC >> 8);  // порт UART2, скорость = BUAD
  UBRR2L = (unsigned char)  BRC; 
  UCSR2B = (1 << TXEN);
  UCSR2C = (1 << UCSZ1) | (1 << UCSZ0);

   EICRA |= (1<<ISC21); //включим прерывания INT2 по нисходящему фронту
   EIMSK |= (1<<INT2);   //разрешим внешние прерывания INT2 
}

 ISR(INT2_vect) //прерывание INT2 (вывод PB2)
{
   PORTD ^= LED0; // мигание светодиодом LED1
   sek++; //внуренний отсчет секунд 
   if (sek==60) sek=0;  
   if (sek%4==0) Flag=2; //каждые 4 сек будем выводить
   if (sek==0) Flag=1; //в начале минуты прочтем часы и синхронизируемся
   
 } 
void out_uart2(byte bb) //посылка UART2 с ожиданием готовности
{
  while (!bitRead(UCSR2A,UDRE));//ожидаем очистки бита UDRE
  UDR2=bb;
}

static uint8_t bcd2bin (uint8_t val) { return val - 6 * (val >> 4); }

void loop() {
 if (Flag==1) { //чтение часов каждую минуту
    Flag=0; //только один раз
    Wire.beginTransmission(0x68);                 // Start I2C protocol with DS1307 address
    Wire.write(0);                                // Send register address
    Wire.endTransmission(false);                  // I2C restart
    Wire.requestFrom(0x68, 7);                    // Request 7 bytes from DS1307 
    second = bcd2bin(Wire.read());                // Read seconds from register 0
    minute = bcd2bin(Wire.read());                // Read minuts from register 1
    hour   = bcd2bin(Wire.read());                // Read hour from register 2
    Wire.read();                                  // Read day-of-week from register 3 (not used)
    date   = bcd2bin(Wire.read());                // Read date from register 4
    month  = bcd2bin(Wire.read());                // Read month from register 5
    year   = bcd2bin(Wire.read());                // Read year from register 6
    sek=second; //синхронизация секунд
 }

if (Flag==2) { //каждые 4 сек выводим
  Flag=0; //только один раз
  byte t_10;
   //выводим с ведущими нулями:
  t_10=date/10; //старший data
  out_uart2(t_10+0x30);
  t_10=date%10; //младший data
  out_uart2(t_10+0x30);
  out_uart2('.'); //точка

  t_10=month/10; //старший month
  out_uart2(t_10+0x30);
  t_10=month%10; //младший month
  out_uart2(t_10+0x30);
  out_uart2('.');  //точка

  t_10=year/10; //старший год
  out_uart2(t_10+0x30);
  t_10=year%10; //младший год
  out_uart2(t_10+0x30);

  out_uart2(0x20); //пробел

  t_10=hour/10; //старший час
  out_uart2(t_10+0x30);
  t_10=hour%10; //младший час
  out_uart2(t_10+0x30);
  out_uart2(':');

  t_10=minute/10; //старший мин
  out_uart2(t_10+0x30);
  t_10=minute%10; //младший мин
  out_uart2(t_10+0x30);
  out_uart2(':');
  t_10=sek/10; //старший sec
  out_uart2(t_10+0x30);
  t_10=sek%10; //младший sec
  out_uart2(t_10+0x30);

  out_uart2(0x0A); //перевод строки 0x0A
  out_uart2(0x0D); //возврат каретки 0x0D
}//end sek%4=0
}//end loop
