/*Установка часов 
 
Arduino Uno, Nano, Mini

СНАЧАЛА ЗАПУСКАЕМ Монитор Порта,
ПОТОМ ЗАГРУЖАЕМ ПРОГРАММУ! 
НЕ ПЕРЕЗАПУСКАТЬ контроллер без перезагрузки программы!!! 
НЕ ЗАПУСКАТЬ Монитор Порта второй раз!!! 

Модель DS1307 по умолчанию
Для модели DS3231:
1. закомментировать RTC_DS1307 RTC; 
   раскомментировать RTC_DS3231 RTC; 
2. закомментировать RTC.writeSqwPinMode(SquareWave1HZ); 
   раскомментировать RTC.writeSqwPinMode(DS3231_SquareWave1Hz);
Если вывод часов SQW используется, то для проверки его установки 
соединить SQW с выводом 13 Arduino - светодиод L должен мигать 1 раз в секунду
*/

#include <Wire.h> //библиотека для TWI
#include <RTClib.h> //библиотека для часов

#define DP 13  // пин D13, мигалка часов 

RTC_DS1307 RTC; //запускаем библиотеку для работы с DS1307 
//RTC_DS3231 RTC; //запускаем библиотеку для работы с DS3231 
DateTime clock;

char daysOfTheWeek[7][12] = {"Voskresenie", "Ponedelnik", "Vtornik", "Sreda", "Chetverg", "Pyatnica", "Subbota"};

void setup() {
  Serial.begin(9600); // Serial-порт для контроля
  if (! RTC.begin()) {
    Serial.println("Couldn't find RTC");
    while (1);
  }
  pinMode(DP,OUTPUT);
/* строка ниже используется для настройки 
времeни и даты из компьютера при смене 
батарейки, уходе или сбое часов:*/
//RTC.adjust(DateTime(__DATE__, __TIME__)); //установка времени
//  RTC.writeSqwPinMode(SquareWave1HZ); //установка выхода SQW 1 Гц для DS3107
//  RTC.writeSqwPinMode(DS3231_SquareWave1Hz); //установка выхода 1 Гц SQW для DS3132
  attachInterrupt(0, impuls, FALLING);   //Прерывание по падающему фронту на D2
}

void impuls()
{
if (digitalRead(DP)==LOW) digitalWrite(DP,HIGH);
else digitalWrite(DP,LOW);
}

void loop() {
  delay(5000);
  uint8_t dayw;
  DateTime clock = RTC.now();
    Serial.print(clock.day(), DEC);
    Serial.print('.');
    Serial.print(clock.month(), DEC);
    Serial.print('.');
    Serial.print(clock.year(), DEC);
    Serial.print(" (");
    Serial.print(daysOfTheWeek[clock.dayOfTheWeek()]);
    dayw=clock.dayOfTheWeek();
    Serial.print(dayw, DEC);
    Serial.print(") ");
    Serial.print(clock.hour(), DEC);
    Serial.print(':');
    Serial.print(clock.minute(), DEC);
    Serial.print(':');
    Serial.print(clock.second(), DEC);
    Serial.println();
}
